/*
 *                       Yeppp! library implementation
 *                   This file is auto-generated by Peach-Py,
 *        Portable Efficient Assembly Code-generator in Higher-level Python,
 *                  part of the Yeppp! library infrastructure
 * This file is part of Yeppp! library and licensed under the New BSD license.
 * See library/LICENSE.txt for the full text of the license.
 */

using System.Runtime.InteropServices;

namespace Yeppp
{

	public partial class Core
	{

		public static unsafe sbyte Min_V8s_S8s(sbyte[] vArray, int vOffset, int length)
		{
			fixed (sbyte* vPointer = &vArray[vOffset])
			{
				return Min_V8s_S8s(vPointer, length);
			}
		}


		public static unsafe byte Min_V8u_S8u(byte[] vArray, int vOffset, int length)
		{
			fixed (byte* vPointer = &vArray[vOffset])
			{
				return Min_V8u_S8u(vPointer, length);
			}
		}


		public static unsafe short Min_V16s_S16s(short[] vArray, int vOffset, int length)
		{
			fixed (short* vPointer = &vArray[vOffset])
			{
				return Min_V16s_S16s(vPointer, length);
			}
		}


		public static unsafe ushort Min_V16u_S16u(ushort[] vArray, int vOffset, int length)
		{
			fixed (ushort* vPointer = &vArray[vOffset])
			{
				return Min_V16u_S16u(vPointer, length);
			}
		}


		public static unsafe int Min_V32s_S32s(int[] vArray, int vOffset, int length)
		{
			fixed (int* vPointer = &vArray[vOffset])
			{
				return Min_V32s_S32s(vPointer, length);
			}
		}


		public static unsafe uint Min_V32u_S32u(uint[] vArray, int vOffset, int length)
		{
			fixed (uint* vPointer = &vArray[vOffset])
			{
				return Min_V32u_S32u(vPointer, length);
			}
		}


		public static unsafe long Min_V64s_S64s(long[] vArray, int vOffset, int length)
		{
			fixed (long* vPointer = &vArray[vOffset])
			{
				return Min_V64s_S64s(vPointer, length);
			}
		}


		public static unsafe ulong Min_V64u_S64u(ulong[] vArray, int vOffset, int length)
		{
			fixed (ulong* vPointer = &vArray[vOffset])
			{
				return Min_V64u_S64u(vPointer, length);
			}
		}


		public static unsafe float Min_V32f_S32f(float[] vArray, int vOffset, int length)
		{
			fixed (float* vPointer = &vArray[vOffset])
			{
				return Min_V32f_S32f(vPointer, length);
			}
		}


		public static unsafe double Min_V64f_S64f(double[] vArray, int vOffset, int length)
		{
			fixed (double* vPointer = &vArray[vOffset])
			{
				return Min_V64f_S64f(vPointer, length);
			}
		}


		public static unsafe void Min_V8sV8s_V8s(sbyte[] xArray, int xOffset, sbyte[] yArray, int yOffset, sbyte[] minimumArray, int minimumOffset, int length)
		{
			fixed (sbyte* xPointer = &xArray[xOffset])
			{
				fixed (sbyte* yPointer = &yArray[yOffset])
				{
					fixed (sbyte* minimumPointer = &minimumArray[minimumOffset])
					{
						Min_V8sV8s_V8s(xPointer, yPointer, minimumPointer, length);
					}
				}
			}
		}


		public static unsafe void Min_V8uV8u_V8u(byte[] xArray, int xOffset, byte[] yArray, int yOffset, byte[] minimumArray, int minimumOffset, int length)
		{
			fixed (byte* xPointer = &xArray[xOffset])
			{
				fixed (byte* yPointer = &yArray[yOffset])
				{
					fixed (byte* minimumPointer = &minimumArray[minimumOffset])
					{
						Min_V8uV8u_V8u(xPointer, yPointer, minimumPointer, length);
					}
				}
			}
		}


		public static unsafe void Min_V16sV16s_V16s(short[] xArray, int xOffset, short[] yArray, int yOffset, short[] minimumArray, int minimumOffset, int length)
		{
			fixed (short* xPointer = &xArray[xOffset])
			{
				fixed (short* yPointer = &yArray[yOffset])
				{
					fixed (short* minimumPointer = &minimumArray[minimumOffset])
					{
						Min_V16sV16s_V16s(xPointer, yPointer, minimumPointer, length);
					}
				}
			}
		}


		public static unsafe void Min_V16uV16u_V16u(ushort[] xArray, int xOffset, ushort[] yArray, int yOffset, ushort[] minimumArray, int minimumOffset, int length)
		{
			fixed (ushort* xPointer = &xArray[xOffset])
			{
				fixed (ushort* yPointer = &yArray[yOffset])
				{
					fixed (ushort* minimumPointer = &minimumArray[minimumOffset])
					{
						Min_V16uV16u_V16u(xPointer, yPointer, minimumPointer, length);
					}
				}
			}
		}


		public static unsafe void Min_V32sV32s_V32s(int[] xArray, int xOffset, int[] yArray, int yOffset, int[] minimumArray, int minimumOffset, int length)
		{
			fixed (int* xPointer = &xArray[xOffset])
			{
				fixed (int* yPointer = &yArray[yOffset])
				{
					fixed (int* minimumPointer = &minimumArray[minimumOffset])
					{
						Min_V32sV32s_V32s(xPointer, yPointer, minimumPointer, length);
					}
				}
			}
		}


		public static unsafe void Min_V32uV32u_V32u(uint[] xArray, int xOffset, uint[] yArray, int yOffset, uint[] minimumArray, int minimumOffset, int length)
		{
			fixed (uint* xPointer = &xArray[xOffset])
			{
				fixed (uint* yPointer = &yArray[yOffset])
				{
					fixed (uint* minimumPointer = &minimumArray[minimumOffset])
					{
						Min_V32uV32u_V32u(xPointer, yPointer, minimumPointer, length);
					}
				}
			}
		}


		public static unsafe void Min_V64sV32s_V64s(long[] xArray, int xOffset, int[] yArray, int yOffset, long[] minimumArray, int minimumOffset, int length)
		{
			fixed (long* xPointer = &xArray[xOffset])
			{
				fixed (int* yPointer = &yArray[yOffset])
				{
					fixed (long* minimumPointer = &minimumArray[minimumOffset])
					{
						Min_V64sV32s_V64s(xPointer, yPointer, minimumPointer, length);
					}
				}
			}
		}


		public static unsafe void Min_V64uV32u_V64u(ulong[] xArray, int xOffset, uint[] yArray, int yOffset, ulong[] minimumArray, int minimumOffset, int length)
		{
			fixed (ulong* xPointer = &xArray[xOffset])
			{
				fixed (uint* yPointer = &yArray[yOffset])
				{
					fixed (ulong* minimumPointer = &minimumArray[minimumOffset])
					{
						Min_V64uV32u_V64u(xPointer, yPointer, minimumPointer, length);
					}
				}
			}
		}


		public static unsafe void Min_V32fV32f_V32f(float[] xArray, int xOffset, float[] yArray, int yOffset, float[] minimumArray, int minimumOffset, int length)
		{
			fixed (float* xPointer = &xArray[xOffset])
			{
				fixed (float* yPointer = &yArray[yOffset])
				{
					fixed (float* minimumPointer = &minimumArray[minimumOffset])
					{
						Min_V32fV32f_V32f(xPointer, yPointer, minimumPointer, length);
					}
				}
			}
		}


		public static unsafe void Min_V64fV64f_V64f(double[] xArray, int xOffset, double[] yArray, int yOffset, double[] minimumArray, int minimumOffset, int length)
		{
			fixed (double* xPointer = &xArray[xOffset])
			{
				fixed (double* yPointer = &yArray[yOffset])
				{
					fixed (double* minimumPointer = &minimumArray[minimumOffset])
					{
						Min_V64fV64f_V64f(xPointer, yPointer, minimumPointer, length);
					}
				}
			}
		}


		public static unsafe void Min_V8sS8s_V8s(sbyte[] xArray, int xOffset, sbyte y, sbyte[] minimumArray, int minimumOffset, int length)
		{
			fixed (sbyte* xPointer = &xArray[xOffset])
			{
				fixed (sbyte* minimumPointer = &minimumArray[minimumOffset])
				{
					Min_V8sS8s_V8s(xPointer, y, minimumPointer, length);
				}
			}
		}


		public static unsafe void Min_V8uS8u_V8u(byte[] xArray, int xOffset, byte y, byte[] minimumArray, int minimumOffset, int length)
		{
			fixed (byte* xPointer = &xArray[xOffset])
			{
				fixed (byte* minimumPointer = &minimumArray[minimumOffset])
				{
					Min_V8uS8u_V8u(xPointer, y, minimumPointer, length);
				}
			}
		}


		public static unsafe void Min_V16sS16s_V16s(short[] xArray, int xOffset, short y, short[] minimumArray, int minimumOffset, int length)
		{
			fixed (short* xPointer = &xArray[xOffset])
			{
				fixed (short* minimumPointer = &minimumArray[minimumOffset])
				{
					Min_V16sS16s_V16s(xPointer, y, minimumPointer, length);
				}
			}
		}


		public static unsafe void Min_V16uS16u_V16u(ushort[] xArray, int xOffset, ushort y, ushort[] minimumArray, int minimumOffset, int length)
		{
			fixed (ushort* xPointer = &xArray[xOffset])
			{
				fixed (ushort* minimumPointer = &minimumArray[minimumOffset])
				{
					Min_V16uS16u_V16u(xPointer, y, minimumPointer, length);
				}
			}
		}


		public static unsafe void Min_V32sS32s_V32s(int[] xArray, int xOffset, int y, int[] minimumArray, int minimumOffset, int length)
		{
			fixed (int* xPointer = &xArray[xOffset])
			{
				fixed (int* minimumPointer = &minimumArray[minimumOffset])
				{
					Min_V32sS32s_V32s(xPointer, y, minimumPointer, length);
				}
			}
		}


		public static unsafe void Min_V32uS32u_V32u(uint[] xArray, int xOffset, uint y, uint[] minimumArray, int minimumOffset, int length)
		{
			fixed (uint* xPointer = &xArray[xOffset])
			{
				fixed (uint* minimumPointer = &minimumArray[minimumOffset])
				{
					Min_V32uS32u_V32u(xPointer, y, minimumPointer, length);
				}
			}
		}


		public static unsafe void Min_V64sS32s_V64s(long[] xArray, int xOffset, int y, long[] minimumArray, int minimumOffset, int length)
		{
			fixed (long* xPointer = &xArray[xOffset])
			{
				fixed (long* minimumPointer = &minimumArray[minimumOffset])
				{
					Min_V64sS32s_V64s(xPointer, y, minimumPointer, length);
				}
			}
		}


		public static unsafe void Min_V64uS32u_V64u(ulong[] xArray, int xOffset, uint y, ulong[] minimumArray, int minimumOffset, int length)
		{
			fixed (ulong* xPointer = &xArray[xOffset])
			{
				fixed (ulong* minimumPointer = &minimumArray[minimumOffset])
				{
					Min_V64uS32u_V64u(xPointer, y, minimumPointer, length);
				}
			}
		}


		public static unsafe void Min_V32fS32f_V32f(float[] xArray, int xOffset, float y, float[] minimumArray, int minimumOffset, int length)
		{
			fixed (float* xPointer = &xArray[xOffset])
			{
				fixed (float* minimumPointer = &minimumArray[minimumOffset])
				{
					Min_V32fS32f_V32f(xPointer, y, minimumPointer, length);
				}
			}
		}


		public static unsafe void Min_V64fS64f_V64f(double[] xArray, int xOffset, double y, double[] minimumArray, int minimumOffset, int length)
		{
			fixed (double* xPointer = &xArray[xOffset])
			{
				fixed (double* minimumPointer = &minimumArray[minimumOffset])
				{
					Min_V64fS64f_V64f(xPointer, y, minimumPointer, length);
				}
			}
		}


		public static unsafe void Min_IV8sV8s_IV8s(sbyte[] xArray, int xOffset, sbyte[] yArray, int yOffset, int length)
		{
			fixed (sbyte* xPointer = &xArray[xOffset])
			{
				fixed (sbyte* yPointer = &yArray[yOffset])
				{
					Min_IV8sV8s_IV8s(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Min_IV8uV8u_IV8u(byte[] xArray, int xOffset, byte[] yArray, int yOffset, int length)
		{
			fixed (byte* xPointer = &xArray[xOffset])
			{
				fixed (byte* yPointer = &yArray[yOffset])
				{
					Min_IV8uV8u_IV8u(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Min_IV16sV16s_IV16s(short[] xArray, int xOffset, short[] yArray, int yOffset, int length)
		{
			fixed (short* xPointer = &xArray[xOffset])
			{
				fixed (short* yPointer = &yArray[yOffset])
				{
					Min_IV16sV16s_IV16s(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Min_IV16uV16u_IV16u(ushort[] xArray, int xOffset, ushort[] yArray, int yOffset, int length)
		{
			fixed (ushort* xPointer = &xArray[xOffset])
			{
				fixed (ushort* yPointer = &yArray[yOffset])
				{
					Min_IV16uV16u_IV16u(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Min_IV32sV32s_IV32s(int[] xArray, int xOffset, int[] yArray, int yOffset, int length)
		{
			fixed (int* xPointer = &xArray[xOffset])
			{
				fixed (int* yPointer = &yArray[yOffset])
				{
					Min_IV32sV32s_IV32s(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Min_IV32uV32u_IV32u(uint[] xArray, int xOffset, uint[] yArray, int yOffset, int length)
		{
			fixed (uint* xPointer = &xArray[xOffset])
			{
				fixed (uint* yPointer = &yArray[yOffset])
				{
					Min_IV32uV32u_IV32u(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Min_IV64sV32s_IV64s(long[] xArray, int xOffset, int[] yArray, int yOffset, int length)
		{
			fixed (long* xPointer = &xArray[xOffset])
			{
				fixed (int* yPointer = &yArray[yOffset])
				{
					Min_IV64sV32s_IV64s(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Min_IV64uV32u_IV64u(ulong[] xArray, int xOffset, uint[] yArray, int yOffset, int length)
		{
			fixed (ulong* xPointer = &xArray[xOffset])
			{
				fixed (uint* yPointer = &yArray[yOffset])
				{
					Min_IV64uV32u_IV64u(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Min_IV32fV32f_IV32f(float[] xArray, int xOffset, float[] yArray, int yOffset, int length)
		{
			fixed (float* xPointer = &xArray[xOffset])
			{
				fixed (float* yPointer = &yArray[yOffset])
				{
					Min_IV32fV32f_IV32f(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Min_IV64fV64f_IV64f(double[] xArray, int xOffset, double[] yArray, int yOffset, int length)
		{
			fixed (double* xPointer = &xArray[xOffset])
			{
				fixed (double* yPointer = &yArray[yOffset])
				{
					Min_IV64fV64f_IV64f(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Min_IV8sS8s_IV8s(sbyte[] xArray, int xOffset, sbyte y, int length)
		{
			fixed (sbyte* xPointer = &xArray[xOffset])
			{
				Min_IV8sS8s_IV8s(xPointer, y, length);
			}
		}


		public static unsafe void Min_IV8uS8u_IV8u(byte[] xArray, int xOffset, byte y, int length)
		{
			fixed (byte* xPointer = &xArray[xOffset])
			{
				Min_IV8uS8u_IV8u(xPointer, y, length);
			}
		}


		public static unsafe void Min_IV16sS16s_IV16s(short[] xArray, int xOffset, short y, int length)
		{
			fixed (short* xPointer = &xArray[xOffset])
			{
				Min_IV16sS16s_IV16s(xPointer, y, length);
			}
		}


		public static unsafe void Min_IV16uS16u_IV16u(ushort[] xArray, int xOffset, ushort y, int length)
		{
			fixed (ushort* xPointer = &xArray[xOffset])
			{
				Min_IV16uS16u_IV16u(xPointer, y, length);
			}
		}


		public static unsafe void Min_IV32sS32s_IV32s(int[] xArray, int xOffset, int y, int length)
		{
			fixed (int* xPointer = &xArray[xOffset])
			{
				Min_IV32sS32s_IV32s(xPointer, y, length);
			}
		}


		public static unsafe void Min_IV32uS32u_IV32u(uint[] xArray, int xOffset, uint y, int length)
		{
			fixed (uint* xPointer = &xArray[xOffset])
			{
				Min_IV32uS32u_IV32u(xPointer, y, length);
			}
		}


		public static unsafe void Min_IV64sS32s_IV64s(long[] xArray, int xOffset, int y, int length)
		{
			fixed (long* xPointer = &xArray[xOffset])
			{
				Min_IV64sS32s_IV64s(xPointer, y, length);
			}
		}


		public static unsafe void Min_IV64uS32u_IV64u(ulong[] xArray, int xOffset, uint y, int length)
		{
			fixed (ulong* xPointer = &xArray[xOffset])
			{
				Min_IV64uS32u_IV64u(xPointer, y, length);
			}
		}


		public static unsafe void Min_IV32fS32f_IV32f(float[] xArray, int xOffset, float y, int length)
		{
			fixed (float* xPointer = &xArray[xOffset])
			{
				Min_IV32fS32f_IV32f(xPointer, y, length);
			}
		}


		public static unsafe void Min_IV64fS64f_IV64f(double[] xArray, int xOffset, double y, int length)
		{
			fixed (double* xPointer = &xArray[xOffset])
			{
				Min_IV64fS64f_IV64f(xPointer, y, length);
			}
		}


		public static unsafe sbyte Min_V8s_S8s(sbyte* vPointer, int length)
		{
			sbyte minimum;
			yepCore_Min_V8s_S8s(vPointer, out minimum, new System.UIntPtr(unchecked((uint) length)));
			return minimum;
		}


		public static unsafe byte Min_V8u_S8u(byte* vPointer, int length)
		{
			byte minimum;
			yepCore_Min_V8u_S8u(vPointer, out minimum, new System.UIntPtr(unchecked((uint) length)));
			return minimum;
		}


		public static unsafe short Min_V16s_S16s(short* vPointer, int length)
		{
			short minimum;
			yepCore_Min_V16s_S16s(vPointer, out minimum, new System.UIntPtr(unchecked((uint) length)));
			return minimum;
		}


		public static unsafe ushort Min_V16u_S16u(ushort* vPointer, int length)
		{
			ushort minimum;
			yepCore_Min_V16u_S16u(vPointer, out minimum, new System.UIntPtr(unchecked((uint) length)));
			return minimum;
		}


		public static unsafe int Min_V32s_S32s(int* vPointer, int length)
		{
			int minimum;
			yepCore_Min_V32s_S32s(vPointer, out minimum, new System.UIntPtr(unchecked((uint) length)));
			return minimum;
		}


		public static unsafe uint Min_V32u_S32u(uint* vPointer, int length)
		{
			uint minimum;
			yepCore_Min_V32u_S32u(vPointer, out minimum, new System.UIntPtr(unchecked((uint) length)));
			return minimum;
		}


		public static unsafe long Min_V64s_S64s(long* vPointer, int length)
		{
			long minimum;
			yepCore_Min_V64s_S64s(vPointer, out minimum, new System.UIntPtr(unchecked((uint) length)));
			return minimum;
		}


		public static unsafe ulong Min_V64u_S64u(ulong* vPointer, int length)
		{
			ulong minimum;
			yepCore_Min_V64u_S64u(vPointer, out minimum, new System.UIntPtr(unchecked((uint) length)));
			return minimum;
		}


		public static unsafe float Min_V32f_S32f(float* vPointer, int length)
		{
			float minimum;
			yepCore_Min_V32f_S32f(vPointer, out minimum, new System.UIntPtr(unchecked((uint) length)));
			return minimum;
		}


		public static unsafe double Min_V64f_S64f(double* vPointer, int length)
		{
			double minimum;
			yepCore_Min_V64f_S64f(vPointer, out minimum, new System.UIntPtr(unchecked((uint) length)));
			return minimum;
		}


		public static unsafe void Min_V8sV8s_V8s(sbyte* xPointer, sbyte* yPointer, sbyte* minimumPointer, int length)
		{
			yepCore_Min_V8sV8s_V8s(xPointer, yPointer, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V8uV8u_V8u(byte* xPointer, byte* yPointer, byte* minimumPointer, int length)
		{
			yepCore_Min_V8uV8u_V8u(xPointer, yPointer, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V16sV16s_V16s(short* xPointer, short* yPointer, short* minimumPointer, int length)
		{
			yepCore_Min_V16sV16s_V16s(xPointer, yPointer, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V16uV16u_V16u(ushort* xPointer, ushort* yPointer, ushort* minimumPointer, int length)
		{
			yepCore_Min_V16uV16u_V16u(xPointer, yPointer, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V32sV32s_V32s(int* xPointer, int* yPointer, int* minimumPointer, int length)
		{
			yepCore_Min_V32sV32s_V32s(xPointer, yPointer, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V32uV32u_V32u(uint* xPointer, uint* yPointer, uint* minimumPointer, int length)
		{
			yepCore_Min_V32uV32u_V32u(xPointer, yPointer, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V64sV32s_V64s(long* xPointer, int* yPointer, long* minimumPointer, int length)
		{
			yepCore_Min_V64sV32s_V64s(xPointer, yPointer, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V64uV32u_V64u(ulong* xPointer, uint* yPointer, ulong* minimumPointer, int length)
		{
			yepCore_Min_V64uV32u_V64u(xPointer, yPointer, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V32fV32f_V32f(float* xPointer, float* yPointer, float* minimumPointer, int length)
		{
			yepCore_Min_V32fV32f_V32f(xPointer, yPointer, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V64fV64f_V64f(double* xPointer, double* yPointer, double* minimumPointer, int length)
		{
			yepCore_Min_V64fV64f_V64f(xPointer, yPointer, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V8sS8s_V8s(sbyte* xPointer, sbyte y, sbyte* minimumPointer, int length)
		{
			yepCore_Min_V8sS8s_V8s(xPointer, y, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V8uS8u_V8u(byte* xPointer, byte y, byte* minimumPointer, int length)
		{
			yepCore_Min_V8uS8u_V8u(xPointer, y, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V16sS16s_V16s(short* xPointer, short y, short* minimumPointer, int length)
		{
			yepCore_Min_V16sS16s_V16s(xPointer, y, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V16uS16u_V16u(ushort* xPointer, ushort y, ushort* minimumPointer, int length)
		{
			yepCore_Min_V16uS16u_V16u(xPointer, y, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V32sS32s_V32s(int* xPointer, int y, int* minimumPointer, int length)
		{
			yepCore_Min_V32sS32s_V32s(xPointer, y, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V32uS32u_V32u(uint* xPointer, uint y, uint* minimumPointer, int length)
		{
			yepCore_Min_V32uS32u_V32u(xPointer, y, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V64sS32s_V64s(long* xPointer, int y, long* minimumPointer, int length)
		{
			yepCore_Min_V64sS32s_V64s(xPointer, y, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V64uS32u_V64u(ulong* xPointer, uint y, ulong* minimumPointer, int length)
		{
			yepCore_Min_V64uS32u_V64u(xPointer, y, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V32fS32f_V32f(float* xPointer, float y, float* minimumPointer, int length)
		{
			yepCore_Min_V32fS32f_V32f(xPointer, y, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_V64fS64f_V64f(double* xPointer, double y, double* minimumPointer, int length)
		{
			yepCore_Min_V64fS64f_V64f(xPointer, y, minimumPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV8sV8s_IV8s(sbyte* xPointer, sbyte* yPointer, int length)
		{
			yepCore_Min_IV8sV8s_IV8s(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV8uV8u_IV8u(byte* xPointer, byte* yPointer, int length)
		{
			yepCore_Min_IV8uV8u_IV8u(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV16sV16s_IV16s(short* xPointer, short* yPointer, int length)
		{
			yepCore_Min_IV16sV16s_IV16s(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV16uV16u_IV16u(ushort* xPointer, ushort* yPointer, int length)
		{
			yepCore_Min_IV16uV16u_IV16u(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV32sV32s_IV32s(int* xPointer, int* yPointer, int length)
		{
			yepCore_Min_IV32sV32s_IV32s(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV32uV32u_IV32u(uint* xPointer, uint* yPointer, int length)
		{
			yepCore_Min_IV32uV32u_IV32u(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV64sV32s_IV64s(long* xPointer, int* yPointer, int length)
		{
			yepCore_Min_IV64sV32s_IV64s(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV64uV32u_IV64u(ulong* xPointer, uint* yPointer, int length)
		{
			yepCore_Min_IV64uV32u_IV64u(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV32fV32f_IV32f(float* xPointer, float* yPointer, int length)
		{
			yepCore_Min_IV32fV32f_IV32f(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV64fV64f_IV64f(double* xPointer, double* yPointer, int length)
		{
			yepCore_Min_IV64fV64f_IV64f(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV8sS8s_IV8s(sbyte* xPointer, sbyte y, int length)
		{
			yepCore_Min_IV8sS8s_IV8s(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV8uS8u_IV8u(byte* xPointer, byte y, int length)
		{
			yepCore_Min_IV8uS8u_IV8u(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV16sS16s_IV16s(short* xPointer, short y, int length)
		{
			yepCore_Min_IV16sS16s_IV16s(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV16uS16u_IV16u(ushort* xPointer, ushort y, int length)
		{
			yepCore_Min_IV16uS16u_IV16u(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV32sS32s_IV32s(int* xPointer, int y, int length)
		{
			yepCore_Min_IV32sS32s_IV32s(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV32uS32u_IV32u(uint* xPointer, uint y, int length)
		{
			yepCore_Min_IV32uS32u_IV32u(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV64sS32s_IV64s(long* xPointer, int y, int length)
		{
			yepCore_Min_IV64sS32s_IV64s(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV64uS32u_IV64u(ulong* xPointer, uint y, int length)
		{
			yepCore_Min_IV64uS32u_IV64u(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV32fS32f_IV32f(float* xPointer, float y, int length)
		{
			yepCore_Min_IV32fS32f_IV32f(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Min_IV64fS64f_IV64f(double* xPointer, double y, int length)
		{
			yepCore_Min_IV64fS64f_IV64f(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V8s_S8s")]
		private static unsafe extern Status yepCore_Min_V8s_S8s(sbyte* v, out sbyte minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V8u_S8u")]
		private static unsafe extern Status yepCore_Min_V8u_S8u(byte* v, out byte minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V16s_S16s")]
		private static unsafe extern Status yepCore_Min_V16s_S16s(short* v, out short minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V16u_S16u")]
		private static unsafe extern Status yepCore_Min_V16u_S16u(ushort* v, out ushort minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V32s_S32s")]
		private static unsafe extern Status yepCore_Min_V32s_S32s(int* v, out int minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V32u_S32u")]
		private static unsafe extern Status yepCore_Min_V32u_S32u(uint* v, out uint minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V64s_S64s")]
		private static unsafe extern Status yepCore_Min_V64s_S64s(long* v, out long minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V64u_S64u")]
		private static unsafe extern Status yepCore_Min_V64u_S64u(ulong* v, out ulong minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V32f_S32f")]
		private static unsafe extern Status yepCore_Min_V32f_S32f(float* v, out float minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V64f_S64f")]
		private static unsafe extern Status yepCore_Min_V64f_S64f(double* v, out double minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V8sV8s_V8s")]
		private static unsafe extern Status yepCore_Min_V8sV8s_V8s(sbyte* x, sbyte* y, sbyte* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V8uV8u_V8u")]
		private static unsafe extern Status yepCore_Min_V8uV8u_V8u(byte* x, byte* y, byte* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V16sV16s_V16s")]
		private static unsafe extern Status yepCore_Min_V16sV16s_V16s(short* x, short* y, short* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V16uV16u_V16u")]
		private static unsafe extern Status yepCore_Min_V16uV16u_V16u(ushort* x, ushort* y, ushort* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V32sV32s_V32s")]
		private static unsafe extern Status yepCore_Min_V32sV32s_V32s(int* x, int* y, int* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V32uV32u_V32u")]
		private static unsafe extern Status yepCore_Min_V32uV32u_V32u(uint* x, uint* y, uint* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V64sV32s_V64s")]
		private static unsafe extern Status yepCore_Min_V64sV32s_V64s(long* x, int* y, long* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V64uV32u_V64u")]
		private static unsafe extern Status yepCore_Min_V64uV32u_V64u(ulong* x, uint* y, ulong* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V32fV32f_V32f")]
		private static unsafe extern Status yepCore_Min_V32fV32f_V32f(float* x, float* y, float* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V64fV64f_V64f")]
		private static unsafe extern Status yepCore_Min_V64fV64f_V64f(double* x, double* y, double* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V8sS8s_V8s")]
		private static unsafe extern Status yepCore_Min_V8sS8s_V8s(sbyte* x, sbyte y, sbyte* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V8uS8u_V8u")]
		private static unsafe extern Status yepCore_Min_V8uS8u_V8u(byte* x, byte y, byte* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V16sS16s_V16s")]
		private static unsafe extern Status yepCore_Min_V16sS16s_V16s(short* x, short y, short* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V16uS16u_V16u")]
		private static unsafe extern Status yepCore_Min_V16uS16u_V16u(ushort* x, ushort y, ushort* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V32sS32s_V32s")]
		private static unsafe extern Status yepCore_Min_V32sS32s_V32s(int* x, int y, int* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V32uS32u_V32u")]
		private static unsafe extern Status yepCore_Min_V32uS32u_V32u(uint* x, uint y, uint* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V64sS32s_V64s")]
		private static unsafe extern Status yepCore_Min_V64sS32s_V64s(long* x, int y, long* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V64uS32u_V64u")]
		private static unsafe extern Status yepCore_Min_V64uS32u_V64u(ulong* x, uint y, ulong* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V32fS32f_V32f")]
		private static unsafe extern Status yepCore_Min_V32fS32f_V32f(float* x, float y, float* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_V64fS64f_V64f")]
		private static unsafe extern Status yepCore_Min_V64fS64f_V64f(double* x, double y, double* minimum, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV8sV8s_IV8s")]
		private static unsafe extern Status yepCore_Min_IV8sV8s_IV8s(sbyte* x, sbyte* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV8uV8u_IV8u")]
		private static unsafe extern Status yepCore_Min_IV8uV8u_IV8u(byte* x, byte* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV16sV16s_IV16s")]
		private static unsafe extern Status yepCore_Min_IV16sV16s_IV16s(short* x, short* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV16uV16u_IV16u")]
		private static unsafe extern Status yepCore_Min_IV16uV16u_IV16u(ushort* x, ushort* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV32sV32s_IV32s")]
		private static unsafe extern Status yepCore_Min_IV32sV32s_IV32s(int* x, int* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV32uV32u_IV32u")]
		private static unsafe extern Status yepCore_Min_IV32uV32u_IV32u(uint* x, uint* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV64sV32s_IV64s")]
		private static unsafe extern Status yepCore_Min_IV64sV32s_IV64s(long* x, int* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV64uV32u_IV64u")]
		private static unsafe extern Status yepCore_Min_IV64uV32u_IV64u(ulong* x, uint* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV32fV32f_IV32f")]
		private static unsafe extern Status yepCore_Min_IV32fV32f_IV32f(float* x, float* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV64fV64f_IV64f")]
		private static unsafe extern Status yepCore_Min_IV64fV64f_IV64f(double* x, double* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV8sS8s_IV8s")]
		private static unsafe extern Status yepCore_Min_IV8sS8s_IV8s(sbyte* x, sbyte y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV8uS8u_IV8u")]
		private static unsafe extern Status yepCore_Min_IV8uS8u_IV8u(byte* x, byte y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV16sS16s_IV16s")]
		private static unsafe extern Status yepCore_Min_IV16sS16s_IV16s(short* x, short y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV16uS16u_IV16u")]
		private static unsafe extern Status yepCore_Min_IV16uS16u_IV16u(ushort* x, ushort y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV32sS32s_IV32s")]
		private static unsafe extern Status yepCore_Min_IV32sS32s_IV32s(int* x, int y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV32uS32u_IV32u")]
		private static unsafe extern Status yepCore_Min_IV32uS32u_IV32u(uint* x, uint y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV64sS32s_IV64s")]
		private static unsafe extern Status yepCore_Min_IV64sS32s_IV64s(long* x, int y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV64uS32u_IV64u")]
		private static unsafe extern Status yepCore_Min_IV64uS32u_IV64u(ulong* x, uint y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV32fS32f_IV32f")]
		private static unsafe extern Status yepCore_Min_IV32fS32f_IV32f(float* x, float y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Min_IV64fS64f_IV64f")]
		private static unsafe extern Status yepCore_Min_IV64fS64f_IV64f(double* x, double y, System.UIntPtr length);

	}

}
