/*
 *                       Yeppp! library implementation
 *                   This file is auto-generated by Peach-Py,
 *        Portable Efficient Assembly Code-generator in Higher-level Python,
 *                  part of the Yeppp! library infrastructure
 * This file is part of Yeppp! library and licensed under the New BSD license.
 * See library/LICENSE.txt for the full text of the license.
 */

using System.Runtime.InteropServices;

namespace Yeppp
{

	public partial class Core
	{

		public static unsafe void Subtract_V8uV8u_V8u(byte[] xArray, int xOffset, byte[] yArray, int yOffset, byte[] differenceArray, int differenceOffset, int length)
		{
			fixed (byte* xPointer = &xArray[xOffset])
			{
				fixed (byte* yPointer = &yArray[yOffset])
				{
					fixed (byte* differencePointer = &differenceArray[differenceOffset])
					{
						Subtract_V8uV8u_V8u(xPointer, yPointer, differencePointer, length);
					}
				}
			}
		}


		public static unsafe void Subtract_V8uV8u_V16u(byte[] xArray, int xOffset, byte[] yArray, int yOffset, ushort[] differenceArray, int differenceOffset, int length)
		{
			fixed (byte* xPointer = &xArray[xOffset])
			{
				fixed (byte* yPointer = &yArray[yOffset])
				{
					fixed (ushort* differencePointer = &differenceArray[differenceOffset])
					{
						Subtract_V8uV8u_V16u(xPointer, yPointer, differencePointer, length);
					}
				}
			}
		}


		public static unsafe void Subtract_V8sV8s_V16s(sbyte[] xArray, int xOffset, sbyte[] yArray, int yOffset, short[] differenceArray, int differenceOffset, int length)
		{
			fixed (sbyte* xPointer = &xArray[xOffset])
			{
				fixed (sbyte* yPointer = &yArray[yOffset])
				{
					fixed (short* differencePointer = &differenceArray[differenceOffset])
					{
						Subtract_V8sV8s_V16s(xPointer, yPointer, differencePointer, length);
					}
				}
			}
		}


		public static unsafe void Subtract_V16uV16u_V16u(ushort[] xArray, int xOffset, ushort[] yArray, int yOffset, ushort[] differenceArray, int differenceOffset, int length)
		{
			fixed (ushort* xPointer = &xArray[xOffset])
			{
				fixed (ushort* yPointer = &yArray[yOffset])
				{
					fixed (ushort* differencePointer = &differenceArray[differenceOffset])
					{
						Subtract_V16uV16u_V16u(xPointer, yPointer, differencePointer, length);
					}
				}
			}
		}


		public static unsafe void Subtract_V16uV16u_V32u(ushort[] xArray, int xOffset, ushort[] yArray, int yOffset, uint[] differenceArray, int differenceOffset, int length)
		{
			fixed (ushort* xPointer = &xArray[xOffset])
			{
				fixed (ushort* yPointer = &yArray[yOffset])
				{
					fixed (uint* differencePointer = &differenceArray[differenceOffset])
					{
						Subtract_V16uV16u_V32u(xPointer, yPointer, differencePointer, length);
					}
				}
			}
		}


		public static unsafe void Subtract_V16sV16s_V32s(short[] xArray, int xOffset, short[] yArray, int yOffset, int[] differenceArray, int differenceOffset, int length)
		{
			fixed (short* xPointer = &xArray[xOffset])
			{
				fixed (short* yPointer = &yArray[yOffset])
				{
					fixed (int* differencePointer = &differenceArray[differenceOffset])
					{
						Subtract_V16sV16s_V32s(xPointer, yPointer, differencePointer, length);
					}
				}
			}
		}


		public static unsafe void Subtract_V32uV32u_V32u(uint[] xArray, int xOffset, uint[] yArray, int yOffset, uint[] differenceArray, int differenceOffset, int length)
		{
			fixed (uint* xPointer = &xArray[xOffset])
			{
				fixed (uint* yPointer = &yArray[yOffset])
				{
					fixed (uint* differencePointer = &differenceArray[differenceOffset])
					{
						Subtract_V32uV32u_V32u(xPointer, yPointer, differencePointer, length);
					}
				}
			}
		}


		public static unsafe void Subtract_V32uV32u_V64u(uint[] xArray, int xOffset, uint[] yArray, int yOffset, ulong[] differenceArray, int differenceOffset, int length)
		{
			fixed (uint* xPointer = &xArray[xOffset])
			{
				fixed (uint* yPointer = &yArray[yOffset])
				{
					fixed (ulong* differencePointer = &differenceArray[differenceOffset])
					{
						Subtract_V32uV32u_V64u(xPointer, yPointer, differencePointer, length);
					}
				}
			}
		}


		public static unsafe void Subtract_V32sV32s_V64s(int[] xArray, int xOffset, int[] yArray, int yOffset, long[] differenceArray, int differenceOffset, int length)
		{
			fixed (int* xPointer = &xArray[xOffset])
			{
				fixed (int* yPointer = &yArray[yOffset])
				{
					fixed (long* differencePointer = &differenceArray[differenceOffset])
					{
						Subtract_V32sV32s_V64s(xPointer, yPointer, differencePointer, length);
					}
				}
			}
		}


		public static unsafe void Subtract_V64uV64u_V64u(ulong[] xArray, int xOffset, ulong[] yArray, int yOffset, ulong[] differenceArray, int differenceOffset, int length)
		{
			fixed (ulong* xPointer = &xArray[xOffset])
			{
				fixed (ulong* yPointer = &yArray[yOffset])
				{
					fixed (ulong* differencePointer = &differenceArray[differenceOffset])
					{
						Subtract_V64uV64u_V64u(xPointer, yPointer, differencePointer, length);
					}
				}
			}
		}


		public static unsafe void Subtract_V32fV32f_V32f(float[] xArray, int xOffset, float[] yArray, int yOffset, float[] differenceArray, int differenceOffset, int length)
		{
			fixed (float* xPointer = &xArray[xOffset])
			{
				fixed (float* yPointer = &yArray[yOffset])
				{
					fixed (float* differencePointer = &differenceArray[differenceOffset])
					{
						Subtract_V32fV32f_V32f(xPointer, yPointer, differencePointer, length);
					}
				}
			}
		}


		public static unsafe void Subtract_V64fV64f_V64f(double[] xArray, int xOffset, double[] yArray, int yOffset, double[] differenceArray, int differenceOffset, int length)
		{
			fixed (double* xPointer = &xArray[xOffset])
			{
				fixed (double* yPointer = &yArray[yOffset])
				{
					fixed (double* differencePointer = &differenceArray[differenceOffset])
					{
						Subtract_V64fV64f_V64f(xPointer, yPointer, differencePointer, length);
					}
				}
			}
		}


		public static unsafe void Subtract_V8uV8u_V8u(byte* xPointer, byte* yPointer, byte* differencePointer, int length)
		{
			yepCore_Subtract_V8uV8u_V8u(xPointer, yPointer, differencePointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Subtract_V8uV8u_V16u(byte* xPointer, byte* yPointer, ushort* differencePointer, int length)
		{
			yepCore_Subtract_V8uV8u_V16u(xPointer, yPointer, differencePointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Subtract_V8sV8s_V16s(sbyte* xPointer, sbyte* yPointer, short* differencePointer, int length)
		{
			yepCore_Subtract_V8sV8s_V16s(xPointer, yPointer, differencePointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Subtract_V16uV16u_V16u(ushort* xPointer, ushort* yPointer, ushort* differencePointer, int length)
		{
			yepCore_Subtract_V16uV16u_V16u(xPointer, yPointer, differencePointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Subtract_V16uV16u_V32u(ushort* xPointer, ushort* yPointer, uint* differencePointer, int length)
		{
			yepCore_Subtract_V16uV16u_V32u(xPointer, yPointer, differencePointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Subtract_V16sV16s_V32s(short* xPointer, short* yPointer, int* differencePointer, int length)
		{
			yepCore_Subtract_V16sV16s_V32s(xPointer, yPointer, differencePointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Subtract_V32uV32u_V32u(uint* xPointer, uint* yPointer, uint* differencePointer, int length)
		{
			yepCore_Subtract_V32uV32u_V32u(xPointer, yPointer, differencePointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Subtract_V32uV32u_V64u(uint* xPointer, uint* yPointer, ulong* differencePointer, int length)
		{
			yepCore_Subtract_V32uV32u_V64u(xPointer, yPointer, differencePointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Subtract_V32sV32s_V64s(int* xPointer, int* yPointer, long* differencePointer, int length)
		{
			yepCore_Subtract_V32sV32s_V64s(xPointer, yPointer, differencePointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Subtract_V64uV64u_V64u(ulong* xPointer, ulong* yPointer, ulong* differencePointer, int length)
		{
			yepCore_Subtract_V64uV64u_V64u(xPointer, yPointer, differencePointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Subtract_V32fV32f_V32f(float* xPointer, float* yPointer, float* differencePointer, int length)
		{
			yepCore_Subtract_V32fV32f_V32f(xPointer, yPointer, differencePointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Subtract_V64fV64f_V64f(double* xPointer, double* yPointer, double* differencePointer, int length)
		{
			yepCore_Subtract_V64fV64f_V64f(xPointer, yPointer, differencePointer, new System.UIntPtr(unchecked((uint) length)));
		}


		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Subtract_V8uV8u_V8u")]
		private static unsafe extern Status yepCore_Subtract_V8uV8u_V8u(byte* x, byte* y, byte* difference, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Subtract_V8uV8u_V16u")]
		private static unsafe extern Status yepCore_Subtract_V8uV8u_V16u(byte* x, byte* y, ushort* difference, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Subtract_V8sV8s_V16s")]
		private static unsafe extern Status yepCore_Subtract_V8sV8s_V16s(sbyte* x, sbyte* y, short* difference, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Subtract_V16uV16u_V16u")]
		private static unsafe extern Status yepCore_Subtract_V16uV16u_V16u(ushort* x, ushort* y, ushort* difference, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Subtract_V16uV16u_V32u")]
		private static unsafe extern Status yepCore_Subtract_V16uV16u_V32u(ushort* x, ushort* y, uint* difference, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Subtract_V16sV16s_V32s")]
		private static unsafe extern Status yepCore_Subtract_V16sV16s_V32s(short* x, short* y, int* difference, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Subtract_V32uV32u_V32u")]
		private static unsafe extern Status yepCore_Subtract_V32uV32u_V32u(uint* x, uint* y, uint* difference, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Subtract_V32uV32u_V64u")]
		private static unsafe extern Status yepCore_Subtract_V32uV32u_V64u(uint* x, uint* y, ulong* difference, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Subtract_V32sV32s_V64s")]
		private static unsafe extern Status yepCore_Subtract_V32sV32s_V64s(int* x, int* y, long* difference, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Subtract_V64uV64u_V64u")]
		private static unsafe extern Status yepCore_Subtract_V64uV64u_V64u(ulong* x, ulong* y, ulong* difference, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Subtract_V32fV32f_V32f")]
		private static unsafe extern Status yepCore_Subtract_V32fV32f_V32f(float* x, float* y, float* difference, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Subtract_V64fV64f_V64f")]
		private static unsafe extern Status yepCore_Subtract_V64fV64f_V64f(double* x, double* y, double* difference, System.UIntPtr length);

	}

}
