/*
 *                       Yeppp! library implementation
 *                   This file is auto-generated by Peach-Py,
 *        Portable Efficient Assembly Code-generator in Higher-level Python,
 *                  part of the Yeppp! library infrastructure
 * This file is part of Yeppp! library and licensed under the New BSD license.
 * See library/LICENSE.txt for the full text of the license.
 */

#include <jni.h>
#include <yepCore.h>
#include <yepJavaPrivate.h>


JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V8uV8u_1V8u(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jbyteArray differenceArray, jint differenceOffset, jint length) {
	enum YepStatus status;
	Yep8u* xPointer = NULL;
	Yep8u* yPointer = NULL;
	Yep8u* differencePointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(differenceArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument differenceArray is null");
		return;
	}
	if YEP_UNLIKELY(differenceOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument differenceOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)differenceOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, differenceArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "differenceOffset + length exceed the length of differenceArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	differencePointer = (*env)->GetPrimitiveArrayCritical(env, differenceArray, NULL);

	status = yepCore_Subtract_V8uV8u_V8u(&xPointer[xOffset], &yPointer[yOffset], &differencePointer[differenceOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, differenceArray, differencePointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V8uV8u_1V16u(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jshortArray differenceArray, jint differenceOffset, jint length) {
	enum YepStatus status;
	Yep8u* xPointer = NULL;
	Yep8u* yPointer = NULL;
	Yep16u* differencePointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(differenceArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument differenceArray is null");
		return;
	}
	if YEP_UNLIKELY(differenceOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument differenceOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)differenceOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, differenceArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "differenceOffset + length exceed the length of differenceArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	differencePointer = (*env)->GetPrimitiveArrayCritical(env, differenceArray, NULL);

	status = yepCore_Subtract_V8uV8u_V16u(&xPointer[xOffset], &yPointer[yOffset], &differencePointer[differenceOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, differenceArray, differencePointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V8sV8s_1V16s(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jshortArray differenceArray, jint differenceOffset, jint length) {
	enum YepStatus status;
	Yep8s* xPointer = NULL;
	Yep8s* yPointer = NULL;
	Yep16s* differencePointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(differenceArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument differenceArray is null");
		return;
	}
	if YEP_UNLIKELY(differenceOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument differenceOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)differenceOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, differenceArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "differenceOffset + length exceed the length of differenceArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	differencePointer = (*env)->GetPrimitiveArrayCritical(env, differenceArray, NULL);

	status = yepCore_Subtract_V8sV8s_V16s(&xPointer[xOffset], &yPointer[yOffset], &differencePointer[differenceOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, differenceArray, differencePointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V16uV16u_1V16u(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jshortArray differenceArray, jint differenceOffset, jint length) {
	enum YepStatus status;
	Yep16u* xPointer = NULL;
	Yep16u* yPointer = NULL;
	Yep16u* differencePointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(differenceArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument differenceArray is null");
		return;
	}
	if YEP_UNLIKELY(differenceOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument differenceOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)differenceOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, differenceArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "differenceOffset + length exceed the length of differenceArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	differencePointer = (*env)->GetPrimitiveArrayCritical(env, differenceArray, NULL);

	status = yepCore_Subtract_V16uV16u_V16u(&xPointer[xOffset], &yPointer[yOffset], &differencePointer[differenceOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, differenceArray, differencePointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V16uV16u_1V32u(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jintArray differenceArray, jint differenceOffset, jint length) {
	enum YepStatus status;
	Yep16u* xPointer = NULL;
	Yep16u* yPointer = NULL;
	Yep32u* differencePointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(differenceArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument differenceArray is null");
		return;
	}
	if YEP_UNLIKELY(differenceOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument differenceOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)differenceOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, differenceArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "differenceOffset + length exceed the length of differenceArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	differencePointer = (*env)->GetPrimitiveArrayCritical(env, differenceArray, NULL);

	status = yepCore_Subtract_V16uV16u_V32u(&xPointer[xOffset], &yPointer[yOffset], &differencePointer[differenceOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, differenceArray, differencePointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V16sV16s_1V32s(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jintArray differenceArray, jint differenceOffset, jint length) {
	enum YepStatus status;
	Yep16s* xPointer = NULL;
	Yep16s* yPointer = NULL;
	Yep32s* differencePointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(differenceArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument differenceArray is null");
		return;
	}
	if YEP_UNLIKELY(differenceOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument differenceOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)differenceOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, differenceArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "differenceOffset + length exceed the length of differenceArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	differencePointer = (*env)->GetPrimitiveArrayCritical(env, differenceArray, NULL);

	status = yepCore_Subtract_V16sV16s_V32s(&xPointer[xOffset], &yPointer[yOffset], &differencePointer[differenceOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, differenceArray, differencePointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V32uV32u_1V32u(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jintArray differenceArray, jint differenceOffset, jint length) {
	enum YepStatus status;
	Yep32u* xPointer = NULL;
	Yep32u* yPointer = NULL;
	Yep32u* differencePointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(differenceArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument differenceArray is null");
		return;
	}
	if YEP_UNLIKELY(differenceOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument differenceOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)differenceOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, differenceArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "differenceOffset + length exceed the length of differenceArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	differencePointer = (*env)->GetPrimitiveArrayCritical(env, differenceArray, NULL);

	status = yepCore_Subtract_V32uV32u_V32u(&xPointer[xOffset], &yPointer[yOffset], &differencePointer[differenceOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, differenceArray, differencePointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V32uV32u_1V64u(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jlongArray differenceArray, jint differenceOffset, jint length) {
	enum YepStatus status;
	Yep32u* xPointer = NULL;
	Yep32u* yPointer = NULL;
	Yep64u* differencePointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(differenceArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument differenceArray is null");
		return;
	}
	if YEP_UNLIKELY(differenceOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument differenceOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)differenceOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, differenceArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "differenceOffset + length exceed the length of differenceArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	differencePointer = (*env)->GetPrimitiveArrayCritical(env, differenceArray, NULL);

	status = yepCore_Subtract_V32uV32u_V64u(&xPointer[xOffset], &yPointer[yOffset], &differencePointer[differenceOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, differenceArray, differencePointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V32sV32s_1V64s(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jlongArray differenceArray, jint differenceOffset, jint length) {
	enum YepStatus status;
	Yep32s* xPointer = NULL;
	Yep32s* yPointer = NULL;
	Yep64s* differencePointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(differenceArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument differenceArray is null");
		return;
	}
	if YEP_UNLIKELY(differenceOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument differenceOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)differenceOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, differenceArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "differenceOffset + length exceed the length of differenceArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	differencePointer = (*env)->GetPrimitiveArrayCritical(env, differenceArray, NULL);

	status = yepCore_Subtract_V32sV32s_V64s(&xPointer[xOffset], &yPointer[yOffset], &differencePointer[differenceOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, differenceArray, differencePointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V64uV64u_1V64u(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jlongArray yArray, jint yOffset, jlongArray differenceArray, jint differenceOffset, jint length) {
	enum YepStatus status;
	Yep64u* xPointer = NULL;
	Yep64u* yPointer = NULL;
	Yep64u* differencePointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(differenceArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument differenceArray is null");
		return;
	}
	if YEP_UNLIKELY(differenceOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument differenceOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)differenceOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, differenceArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "differenceOffset + length exceed the length of differenceArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	differencePointer = (*env)->GetPrimitiveArrayCritical(env, differenceArray, NULL);

	status = yepCore_Subtract_V64uV64u_V64u(&xPointer[xOffset], &yPointer[yOffset], &differencePointer[differenceOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, differenceArray, differencePointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V32fV32f_1V32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloatArray yArray, jint yOffset, jfloatArray differenceArray, jint differenceOffset, jint length) {
	enum YepStatus status;
	Yep32f* xPointer = NULL;
	Yep32f* yPointer = NULL;
	Yep32f* differencePointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(differenceArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument differenceArray is null");
		return;
	}
	if YEP_UNLIKELY(differenceOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument differenceOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)differenceOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, differenceArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "differenceOffset + length exceed the length of differenceArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	differencePointer = (*env)->GetPrimitiveArrayCritical(env, differenceArray, NULL);

	status = yepCore_Subtract_V32fV32f_V32f(&xPointer[xOffset], &yPointer[yOffset], &differencePointer[differenceOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, differenceArray, differencePointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V64fV64f_1V64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdoubleArray yArray, jint yOffset, jdoubleArray differenceArray, jint differenceOffset, jint length) {
	enum YepStatus status;
	Yep64f* xPointer = NULL;
	Yep64f* yPointer = NULL;
	Yep64f* differencePointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(differenceArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument differenceArray is null");
		return;
	}
	if YEP_UNLIKELY(differenceOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument differenceOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)differenceOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, differenceArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "differenceOffset + length exceed the length of differenceArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	differencePointer = (*env)->GetPrimitiveArrayCritical(env, differenceArray, NULL);

	status = yepCore_Subtract_V64fV64f_V64f(&xPointer[xOffset], &yPointer[yOffset], &differencePointer[differenceOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, differenceArray, differencePointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}
