/*
 *                       Yeppp! library implementation
 *                   This file is auto-generated by Peach-Py,
 *        Portable Efficient Assembly Code-generator in Higher-level Python,
 *                  part of the Yeppp! library infrastructure
 * This file is part of Yeppp! library and licensed under the New BSD license.
 * See library/LICENSE.txt for the full text of the license.
 */

#include <yepIntrinsics.h>
#include <yepCore.h>


extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_SumAbs_V32f_S32f_Default(const Yep32f *YEP_RESTRICT vPointer, Yep32f *YEP_RESTRICT sumAbsPointer, YepSize length) {
	if YEP_UNLIKELY(vPointer == YEP_NULL_POINTER) {
		return YepStatusNullPointer;
	}
	if YEP_UNLIKELY(yepBuiltin_GetPointerMisalignment(vPointer, sizeof(Yep32f)) != 0) {
		return YepStatusMisalignedPointer;
	}
	if YEP_UNLIKELY(sumAbsPointer == YEP_NULL_POINTER) {
		return YepStatusNullPointer;
	}
	if YEP_UNLIKELY(yepBuiltin_GetPointerMisalignment(sumAbsPointer, sizeof(Yep32f)) != 0) {
		return YepStatusMisalignedPointer;
	}
	Yep32f sumAbs = Yep32f(0);
	while (length-- != 0) {
		const Yep32f v = *vPointer++;
		sumAbs += yepBuiltin_Abs_32f_32f(v);
	}
	*sumAbsPointer = sumAbs;
	return YepStatusOk;
}

extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_SumAbs_V64f_S64f_Default(const Yep64f *YEP_RESTRICT vPointer, Yep64f *YEP_RESTRICT sumAbsPointer, YepSize length) {
	if YEP_UNLIKELY(vPointer == YEP_NULL_POINTER) {
		return YepStatusNullPointer;
	}
	if YEP_UNLIKELY(yepBuiltin_GetPointerMisalignment(vPointer, sizeof(Yep64f)) != 0) {
		return YepStatusMisalignedPointer;
	}
	if YEP_UNLIKELY(sumAbsPointer == YEP_NULL_POINTER) {
		return YepStatusNullPointer;
	}
	if YEP_UNLIKELY(yepBuiltin_GetPointerMisalignment(sumAbsPointer, sizeof(Yep64f)) != 0) {
		return YepStatusMisalignedPointer;
	}
	Yep64f sumAbs = Yep64f(0);
	while (length-- != 0) {
		const Yep64f v = *vPointer++;
		sumAbs += yepBuiltin_Abs_64f_64f(v);
	}
	*sumAbsPointer = sumAbs;
	return YepStatusOk;
}
